-- This file is part of the it-crafts software and is subject to copyright protection.
-- (C) 2022..2023, All rights reserved by Steffen Anders, Elsteraue - Germany
-- Visit also https://www.it-crafts.de.
--

IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_GuidAndRecId')
BEGIN
CREATE TABLE [dbo].[ut_GuidAndRecId]
(
  [RecId]  integer NOT NULL
 ,[mGuid] char(36) DEFAULT ''
 ,[mRecId] integer DEFAULT 0
  CONSTRAINT [Pk_GuidAndRecId]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO

-- drop obsolete triggers and the triggered table with keyvalues
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_GuidAndRecId_KeyDel')
  DROP TRIGGER [dbo].[tr_GuidAndRecId_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_GuidAndRecId_KeyUpd')
  DROP TRIGGER [dbo].[tr_GuidAndRecId_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_GuidAndRecId_Keys')
  DROP TABLE [dbo].[ut_GuidAndRecId_Keys]
GO

-- add new fields
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_GuidAndRecId' and sc.[name] = 'mGuid')
BEGIN
  ALTER TABLE [dbo].[ut_GuidAndRecId] ADD [mGuid] char(36) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_GuidAndRecId' and sc.[name] = 'mRecId')
BEGIN
  ALTER TABLE [dbo].[ut_GuidAndRecId] ADD [mRecId] integer NOT NULL DEFAULT 0
END
GO

-- check lengths of fields
IF 36 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_GuidAndRecId' and sc.[name] = 'mGuid')
BEGIN
   ALTER TABLE [dbo].[ut_GuidAndRecId] ALTER COLUMN [mGuid] char(36)
END
GO

-- create dedicated view
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'GuidAndRecId')
  DROP VIEW [dbo].[GuidAndRecId]
GO
CREATE VIEW [dbo].[GuidAndRecId] AS
  SELECT [RecId]
 ,[mGuid]
 ,[mRecId]
  FROM [dbo].[ut_GuidAndRecId]
GO


-- create function to get the next RecId
IF OBJECT_ID (N'itcfunc_NextRecId_GuidAndRecId', N'FN') IS NOT NULL
  DROP FUNCTION dbo.itcfunc_NextRecId_GuidAndRecId
GO
CREATE FUNCTION dbo.itcfunc_NextRecId_GuidAndRecId() RETURNS integer
AS
BEGIN
  RETURN isnull((SELECT MAX(RecId) FROM [dbo].[ut_GuidAndRecId] WITH (READUNCOMMITTED)),0) + 1
END
GO

-- select with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Sel_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Sel_GuidAndRecId]  @mRI integer
AS
  SELECT
    [mGuid]
   ,[mRecId]
  FROM [dbo].[ut_GuidAndRecId] WHERE RecId = @mRI
GO

-- select with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel2_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Sel2_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Sel2_GuidAndRecId]  @Param_RecId varchar(20)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  SELECT * FROM [dbo].[GuidAndRecId] WHERE RecId = @mRI
GO

-- insert with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Append_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Append_GuidAndRecId]
   @Param_mGuid char(36)
  ,@Param_mRecId integer
AS
  DECLARE @NeueId integer
  DECLARE @m_CountDown integer = 10
  WHILE @m_CountDown > 0 BEGIN
    BEGIN TRANSACTION
    BEGIN TRY
      SET @NeueId = dbo.itcfunc_NextRecId_GuidAndRecId()
      INSERT INTO [dbo].[ut_GuidAndRecId] (RecId
        ,[mGuid]
        ,[mRecId]
          ) VALUES (@NeueId
        ,UPPER(RTRIM(@Param_mGuid))
        ,@Param_mRecId
          )
      COMMIT TRANSACTION
    END TRY
    BEGIN CATCH
      ROLLBACK TRANSACTION
      SET @NeueId = 0
    END CATCH

    IF @NeueId <> 0
      SET @m_CountDown = 0
    ELSE
      SET @m_CountDown = @m_CountDown - 1

    IF @m_CountDown > 0
      WAITFOR DELAY '00:00:00.050'
  END -- WHILE
  SELECT @NeueId AS RecId
GO

-- insert with obsolete clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Add_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Add_GuidAndRecId]
AS
  DECLARE @NeueId integer = dbo.itcfunc_NextRecId_GuidAndRecId()
  INSERT INTO [dbo].[ut_GuidAndRecId] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
    SELECT @NeueId AS RecId
  ELSE
    SELECT 0 AS RecId
GO

-- update with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Upd_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Upd_GuidAndRecId] @mRI integer
  ,@Param_mGuid char(36)
  ,@Param_mRecId integer
AS
  UPDATE [dbo].[ut_GuidAndRecId] SET
    [mGuid] = UPPER(RTRIM(@Param_mGuid))
   ,[mRecId] = @Param_mRecId
  WHERE RecId = @mRI
GO

-- update with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd2_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Upd2_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Upd2_GuidAndRecId] @Param_RecId varchar(20)
  ,@Param_mGuid varchar(36)
  ,@Param_mRecId varchar(8)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  UPDATE [dbo].[ut_GuidAndRecId] SET
    [mGuid] = UPPER(RTRIM(@Param_mGuid))
   ,[mRecId] = dbo.itcfunc_integer(@Param_mRecId)
  WHERE RecId = @mRI

  EXECUTE [dbo].[up_Sel2_GuidAndRecId] @mRI
GO

-- delete
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Del_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Del_GuidAndRecId] @mRI integer
AS
  DELETE FROM [dbo].[ut_GuidAndRecId] WHERE RecId = @mRI
GO

-- text index
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_TrSel_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_TrSel_GuidAndRecId]
AS
  SELECT RecId,
    LTRIM(RTRIM([mGuid]))
  AS Data FROM [dbo].[ut_GuidAndRecId] WHERE RecId > 0 ORDER BY RecId
GO

-- reindex
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_GuidAndRecId')
  DROP PROCEDURE [dbo].[up_Reorg_GuidAndRecId]
GO
CREATE PROCEDURE [dbo].[up_Reorg_GuidAndRecId] @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_GuidAndRecId] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_GuidAndRecId] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_GuidAndRecId] )
  END
GO

-- logical key  ORDER BY mGuid,RecId
IF 0 < (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_GuidAndRecId' and so.[id] = si.[id] and si.[name] = 'Ik_Key00')
  DROP INDEX [Ik_Key00] ON [dbo].[ut_GuidAndRecId]
GO
IF 0 = (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_GuidAndRecId' and so.[id] = si.[id] and si.[name] = 'Ik_Key00')
  CREATE INDEX [Ik_Key00] ON [dbo].[ut_GuidAndRecId] (mGuid,RecId)
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_First_GuidAndRecId_Key00]
GO
CREATE PROCEDURE [dbo].[up_First_GuidAndRecId_Key00] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00) ORDER BY mGuid,RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_First_GuidAndRecId_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_First_GuidAndRecId_Key00] AS EXECUTE [dbo].[up_First_GuidAndRecId_Key00]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_Last_GuidAndRecId_Key00]
GO
CREATE PROCEDURE [dbo].[up_Last_GuidAndRecId_Key00] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00) ORDER BY mGuid desc,RecId desc
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Last_GuidAndRecId_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_Last_GuidAndRecId_Key00] AS EXECUTE [dbo].[up_Last_GuidAndRecId_Key00]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_Next_GuidAndRecId_Key00]
GO
CREATE PROCEDURE [dbo].[up_Next_GuidAndRecId_Key00] @oldRecId integer AS
  DECLARE @oldmGuid char(36)
  SELECT @oldmGuid = mGuid FROM [dbo].[ut_GuidAndRecId] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00)
    WHERE (mGuid > @oldmGuid)
    ORDER BY mGuid,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next_GuidAndRecId_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_Next_GuidAndRecId_Key00] @oldRecId integer AS EXECUTE [dbo].[up_Next_GuidAndRecId_Key00] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_Prior_GuidAndRecId_Key00]
GO
CREATE PROCEDURE [dbo].[up_Prior_GuidAndRecId_Key00] @oldRecId integer AS
  DECLARE @oldmGuid char(36)
  SELECT @oldmGuid = mGuid FROM [dbo].[ut_GuidAndRecId] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00)
    WHERE (mGuid < @oldmGuid)
    ORDER BY mGuid desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior_GuidAndRecId_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_Prior_GuidAndRecId_Key00] @oldRecId integer AS EXECUTE [dbo].[up_Prior_GuidAndRecId_Key00] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_Next50_GuidAndRecId_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next50_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[qp_Next50_GuidAndRecId_Key00]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_Prior50_GuidAndRecId_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior50_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[qp_Prior50_GuidAndRecId_Key00]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_FindF_GuidAndRecId_Key00]
GO
CREATE PROCEDURE [dbo].[up_FindF_GuidAndRecId_Key00] @xKey char(250), @xLen integer AS
  DECLARE @mmGuid char(36) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,36)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 36 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00) WHERE 
      mGuid = @mmGuid
      ORDER BY mGuid,RecId
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 36 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00) WHERE 
      mGuid >= @mmGuid AND SUBSTRING(mGuid,1,LEN(@mmGuid)) = @mmGuid
      ORDER BY mGuid,RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindF_GuidAndRecId_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindF_GuidAndRecId_Key00] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindF_GuidAndRecId_Key00] @xKey, @xLen')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_GuidAndRecId_Key00')
  DROP PROCEDURE [dbo].[up_FindL_GuidAndRecId_Key00]
GO
CREATE PROCEDURE [dbo].[up_FindL_GuidAndRecId_Key00] @xKey char(250), @xLen integer AS
  DECLARE @mmGuid char(36) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,36)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 36 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00) WHERE 
      mGuid = @mmGuid
      ORDER BY mGuid desc,RecId desc
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 36 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_GuidAndRecId] WITH(INDEX = Ik_Key00) WHERE 
      SUBSTRING(mGuid,1,LEN(@mmGuid)) = @mmGuid
      ORDER BY mGuid desc,RecId desc
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindL_GuidAndRecId_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindL_GuidAndRecId_Key00] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindL_GuidAndRecId_Key00] @xKey, @xLen')
GO


